module Spec
  module SeedHelpers

    def create_double_beaneater_pool(opts={})
      @connection = double("Beaneater::Pool")
      allow(@connection).to receive(:jobs).and_return( opts[:jobs] )
      allow(@connection).to receive(:tubes).and_return( opts[:tubes] )
      @connection
    end

    def create_double_beaneater_tube(opts={})
      tube = double("Beaneater::Tube")
      allow(tube).to receive(:name).and_return( opts[:name] )
      allow(tube).to receive(:stats).and_return( opts[:stats] )
      allow(tube).to receive(:put).with(kind_of(String), kind_of(Hash)).and_return( opts[:put_response] )
      tube
    end

    def create_stats(opts={})
      stats = OpenStruct.new(opts)
      stats
    end

    def create_double_beaneater_job(opts={})
      job = double("Beaneater::Job")
      allow(job).to receive(:stats).and_return(opts[:stats])
      allow(job).to receive(:body).and_return(opts[:body])
      allow(job).to receive(:delete)
      job
    end

    def create_double_beaneater_jobs(jobs)
      double_jobs = double
      jobs.each do |key, value|
        allow(double_jobs).to receive(:find_all).with(key).and_return( [value] )
      end
      double_jobs
    end

    def create_double_subscriber
      subscriber = double
      allow(subscriber).to receive(:state_changed).with(kind_of(Account), kind_of(String), kind_of(String))
      subscriber
    end

    def create_double_logger
      logger = double
      allow(logger).to receive(:warn).with(kind_of(String))
      allow(logger).to receive(:info).with(kind_of(String))
      logger
    end

    def create_double_airbrake
      airbrake = double
      allow(airbrake).to receive(:notify).with(kind_of(Hash))
      airbrake
    end

    def create_worker_response
      {
        :name => "Customer Name",
        :address => "Customer Home Address",
        :amount_due => 12345,
        :amount_cents => 12345,
        :_bill_number => "ABC123",
        :raw => "ABC|123|"
      }
    end

    def create_worker_exception
      {
        :code => 1001,
        :message => 'Internal error exception',
        :type => 'XBP::Error::ApiInternalError'
      }
    end

  end
end

RSpec.configure do |config|
  config.include Spec::SeedHelpers
end